//
//  ISMPowerNotifier.h
//  iStatMenusTemps
//
//  
//  Copyright 2010 Bjango. All rights reserved.
//

#import <Foundation/Foundation.h>
#include <IOKit/IOKitLib.h>
#include <IOKit/ps/IOPSKeys.h>
#include <IOKit/ps/IOPowerSources.h>
#include <IOKit/pwr_mgt/IOPMLib.h>
#include <IOKit/IOMessage.h>

#define PowerSourceUnknown -1
#define PowerSourceBattery 0
#define PowerSourceAC 1

#define PowerStateUnknown -1
#define PowerStateDraining 0
#define PowerStateCharging 1
#define PowerStateCharged 2


#ifndef PowerNotifierSourceChanged
#define PowerNotifierSourceChanged @"PowerNotifierSourceChanged"
#define PowerNotifierStateChanged @"PowerNotifierStateChanged"
#define PowerNotifierWake @"PowerNotifierWake"
#define PowerNotifierSleep @"PowerNotifierSleep"
#endif

@interface BJAPowerManager : NSObject {
#ifdef POWERNOTIFIER_IOKIT
	io_connect_t rootPort;
	io_object_t notifier;
    IONotificationPortRef notificationPort;
#endif
	CFRunLoopSourceRef powerNotifierRunLoopSource;
}

@property (nonatomic) NSInteger source;
@property (nonatomic) NSInteger state;

+ (BJAPowerManager *)sharedPowerManager;
- (void)unregisterNotifications;

#ifdef POWERNOTIFIER_IOKIT
- (void)powerMessageReceived:(natural_t)messageType withArgument:(void *)messageArgument;
#endif

@end
